local function isCorpseDisposalEnabled()
	if CorpseDisposalMod.KeepCorpses then
		return false
	end

	return managers.groupai:state():enemy_weapons_hot()
end

local function slowDisposal()
	local time = CorpseDisposalMod.DespawnTime or 3

	if CorpseDisposalMod.UseSlowDispose then
		return TimerManager:game():time() + time
	end

	return time
end

local function dispose_corpse(self, dead_unit, damage_info)
	local u_key = dead_unit:key()

	if isCorpseDisposalEnabled() and Network:is_server() and not IgnoreList[dead_unit:name():key()] then
		DelayedCalls:Add(tostring(u_key), slowDisposal(), function()
			if alive(dead_unit) then
				dead_unit:set_slot(0)
				if managers.network:session() then
					managers.network:session():send_to_peers_synched("remove_corpse_by_id", dead_unit:id(), true, managers.network:session():local_peer():id())
				end
				Network:detach_unit(dead_unit)
				managers.enemy._enemy_data.corpses[u_key] = nil
			end
		end)
	end
end

Hooks:PostHook(EnemyManager, "on_enemy_died", "func_on_death", function(self, dead_unit, damage_info)
	dispose_corpse(self, dead_unit, damage_info)
end)

Hooks:PostHook(EnemyManager, "on_civilian_died", "func_on_death_civ", function(self, dead_unit, damage_info)
	if not CorpseDisposalMod.OnlyEnemies then
		dispose_corpse(self, dead_unit, damage_info)
	end
end)

function EnemyManager:is_corpse_disposal_enabled()
	return false
end

function EnemyManager:set_corpse_disposal_enabled(state)
end